

function updateCheckboxHiddenField(checkBoxObj) {
	if (checkBoxObj) {
       var prefixIndex = checkBoxObj.id.indexOf("cb_");
       if ( prefixIndex >= 0) {
        // Remove the cb_ prefix.
       	tempName = checkBoxObj.id.substring(3);
       	if (document.getElementsByName(tempName)[0]) {
       		document.getElementsByName(tempName)[0].value = checkBoxObj.checked;
       	}
       }
    }
}

function selectAllWithPrefix(prefix){
    theForm = document.forms[0];

    for (i=0;i<theForm.length;i++) {

        if ((theForm[i].type == "checkbox") && (theForm[i].id.indexOf(prefix) >= 0)) {
            theForm[i].checked = true;
            updateCheckboxHiddenField(theForm[i]);
            findParentRow(theForm.elements[i],"table-row-selected");
        }
    }
}

function deselectAllWithPrefix(prefix){
    theForm = document.forms[0];

    for (i=0;i<theForm.length;i++) {

        if ((theForm[i].type == "checkbox") && (theForm[i].id.indexOf(prefix) >= 0)) {
            theForm[i].checked = false;
            updateCheckboxHiddenField(theForm[i]);
            findParentRow(theForm.elements[i],"table-row");
        }
    }
}

function collectionSelectAll(prefix) {
	selectAllWithPrefix(prefix+"detailFormSelected");
}

function collectionDeselectAll(prefix) {
	deselectAllWithPrefix(prefix+"detailFormSelected");
}

if (isDom) {
    showString = "table-row-group";
} else {
    showString = "inline";
}

function SortingDo(inputObjId, prefix, columnStr, orderStr) {
	document.getElementById(prefix+"column").value =  columnStr;
	document.getElementById(prefix+"order").value =  orderStr;
	document.getElementById(prefix+"SortAction").disabled =  false;
	document.getElementById(inputObjId).form.submit();
}

function EnableElement(prefix, id){
	document.getElementById(prefix+id).disabled =  false;
}

function DisableElement(prefix, id){
	document.getElementById(prefix+id).disabled =  true;
}


function EnableAndSubmit(prefix, id) {
    EnableElement(prefix, id)
	document.getElementById(prefix+id).form.submit();
}

//submit with request para/value pairs
function SubmitWithParameters()
{
   var theForm = document.forms[0];
   for(var j=0; j<arguments.length/2; j++){
		var newInput = document.createElement('Input');
		newInput.setAttribute("type", "hidden");
		newInput.setAttribute("value", arguments[j*2+1]);
		newInput.setAttribute("name", arguments[j*2]);
		theForm.appendChild(newInput);
   } 
   theForm.submit();     
}


function showHideFilter(prefix) {
    var filterTableImg = document.getElementById (prefix+"filterTableImg");
    var disFilter = "";
    if (filterTableImg.src.indexOf("wtable_filter_row_show") > 0) {
        disFilter = showString;
        filterTableImg.src = jsRepository["contextPath"]+"/images/wtable_filter_row_hide.gif";
        filterTableImg.title = jsRepository["msg_hide.filter"];
    } else {
        filterTableImg.src = jsRepository["contextPath"]+"/images/wtable_filter_row_show.gif";
        filterTableImg.title = jsRepository["msg_show.filter"];
        disFilter = "none";
    }

    document.getElementById(prefix+"filterControls").style.display = disFilter;
}


function clearFilter(prefix) {
    elements = document.getElementsByName(prefix+"searchPatternProxy");
    for(var i = 0; i<elements.length; i++){
    	elements[i].value="*";
    }
    collectionDeselectAll(prefix);
    document.getElementById(prefix+"searchActionButton").click();
}

function onenter(e, prefix) {
    var keyCodeChar  
      
	if (e && e.which){
        e = e;
        keyCodeChar = e.which;
    }
    else{
        e = event;
        keyCodeChar = e.keyCode;
    }
    
    if (keyCodeChar == 13){
		document.getElementById(prefix+"searchActionButton").click();
        return false;
    }
	else{
		return true;
    }
}

var jsRepository = new Array();

	
function updateSearchPattern(prefix){
	filterOptions = jsRepository[prefix+"filterOptions"];
	filterText = jsRepository[prefix+"filterText"];
	var filterValue = document.getElementById(prefix+"searchFilterProxy").value;
	var searchPattern = document.getElementById(prefix+"searchPatternProxy").value;
	for (var i=0; i < filterOptions.length; i++){
		if(filterValue == filterOptions[i][0]){
			var selectInput = document.getElementById(prefix+"SelectBoxFilterInput");
			var textInput = document.getElementById(prefix+"rawTextFilterInput");
			var selectBox = document.getElementById(prefix+"searchPatternSelect");
			var textBox = document.getElementById(prefix+"searchPatternProxy");
			if(filterOptions[i].length == 1){
				selectInput.style.display="none";
				textInput.style.display="";
				selectBox.name="unused";
				textBox.name=prefix+"searchPatternProxy";
			}
			else{
				selectInput.style.display="";
				textInput.style.display="none";
				textBox.name="unused";
				selectBox.name=prefix+"searchPatternProxy";
				selectBox.options.length=0;
				selectBox.options[0]=new Option("*","*");
				for(var j=0; j < filterOptions[i].length-1; j++){
					selectBox.options[j+1]=new Option(filterText[i][j],filterOptions[i][j+1]);
					if(filterText[i][j] == searchPattern){
						selectBox.options[j+1].selected="True";
					}
				}
			}
			return;
		}
	}
}

function EnableFilter(prefix)
{
	document.getElementsByName(prefix+"searchFilter")[0].value =  document.getElementsByName(prefix+"searchFilterProxy")[0].value;
	document.getElementsByName(prefix+"searchPattern")[0].value =  document.getElementsByName(prefix+"searchPatternProxy")[0].value;
	EnableElement(prefix,'searchAction')
	EnableElement(prefix,'searchFilter')
	EnableElement(prefix,'searchPattern')
}

//this function improved enableDisable() in menu_functions.js, such that different controls can be enabled disabled at same time. "!" applies to sub control, not the master
function enableDisable2(controlSet,origin) {

    if (origin != "reset") {
        enableDisableArray[enableDisableArray.length] = controlSet;
    }

    controlArray = controlSet.split(",");

    // set up variable default values
    disStatus = false;
    textStyle = "textEntry";
    textColor = "#000000";
    textAreaStyle = "textAreaEntry";

    // loop through controls to assign enablement/disablement to children
    for (i=0;i<controlArray.length;i++) {

        tmp = controlArray[i];

        cArray = tmp.split(":");

        // if this control is a master of 1 or more controls
        if (cArray.length > 1) {

            // master control is at 0
            masterControlId = cArray[0];
            var flip = false;
//            if (masterControlId.substr(0,1) == "!") {
//            	masterControlId = masterControlId.substr(1);
//            	flip = true;
//            }
            if (document.getElementById (masterControlId)) {
                 masterControlStatus = document.getElementById(masterControlId).checked;
                 masterControlStatusdisabled = document.getElementById(masterControlId).disabled;
//	            if (flip) {
//	            	masterControlStatus = !masterControlStatus;
//	            }
            }

            //alert("master = "+masterControlId + "   " +masterControlStatus);



            for (j=1;j<cArray.length;j++) {
            	elemId = cArray[j];
                if (elemId.substr(0,1) == "!") {
                	elemId = elemId.substr(1);
                	flip = true;
                } else 
                	flip = false;

                // determine variable values for children based on master attribute
                // CHECKED attribute applies to both checkbox and radio buttons
                // For radio buttons, make sure ID attribute is assigned to the value of that
                // specific radio button
                if (masterControlStatus && !flip || !masterControlStatus && flip ) {
                    disStatus = false;
                    textStyle = "textEntry";
                    textColor = "#000000";
                    textAreaStyle = "textAreaEntry";
                } else {
                    disStatus = true;
                    textStyle = "textEntryReadOnly";
                    textColor = "#CCCCCC";
                    textAreaStyle = "textAreaEntryReadOnly";
                }
                
                if (document.getElementById(elemId)) {
                    // If child control is required, then "+Required" follows child control id
                    // If child control is long, then "+Long" follows
                    rcArray = elemId.split("+");
                    if (rcArray.length > 1) {
                        textStyle = textStyle+rcArray[1];
                        elemId = rcArray[0];
                    }

                    // assign child control styles according to type
                    //alert(document.getElementById(elemId).style.width);
                    //alert(document.getElementById(elemId).type);
                    if ((document.getElementById(elemId).type == "text") ||
                        (document.getElementById(elemId).type == "password")) {
                        document.getElementById(elemId).className = textStyle;
                    }
                    if (document.getElementById(elemId).type == "textarea") {
                        document.getElementById(elemId).className = textAreaStyle;
                    }
                    if (isDom) {
                        document.getElementById(elemId).parentNode.style.color = textColor;
                    } else {
                        document.getElementById(elemId).parentElement.style.color = textColor;
                    }
                    document.getElementById(elemId).disabled = disStatus;
                }
            }


        }

    }
}

// Observer support
var Observers= new Array()
function Observer(subject, todo)
{
   this.subject = subject
   this.todo = todo
//   alert(subject +"  "+ todo)
}

function RegisterObserver(key, todo)
{
   var obs = new Observer(key, todo)
   var obsArray = Observers[key]
   if(obsArray == undefined)
   {
      obsArray = new Array()
      Observers[key] = obsArray 
   }
   obsArray[obsArray.length] = obs
}

function Notify(key)
{
   var paras= new Array()
   for(var j=1; j<arguments.length; j++)
      paras[j-1] = arguments[j]

   obsArray = Observers[key]
   if(obsArray == undefined)
      return
      
   for(var i=0; i<obsArray.length; i++){
      obs = obsArray[i]
      obs.todo(paras)
   }
}


//function doso(paras)
//{
//   alert("do something")
//   alert(paras[0])
//}

//RegisterObserver("test", doso)
//Notify("test", 234, "argu2")